## mummy 1.0.2

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.3 FATAL_ERROR)
PROJECT(Mummy)

# Determine if we're building Mummy as a "top level" project.
#
SET(Mummy_BUILD_IS_TOP_LEVEL 0)
IF("${Mummy_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  SET(Mummy_BUILD_IS_TOP_LEVEL 1)
ENDIF("${Mummy_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Version number and default installation location:
#
SET(Mummy_VERSION_MAJOR 1)
SET(Mummy_VERSION_MINOR 0)
SET(Mummy_VERSION_PATCH 2)
SET(Mummy_VERSION_STRING "${Mummy_VERSION_MAJOR}.${Mummy_VERSION_MINOR}.${Mummy_VERSION_PATCH}")
IF(Mummy_BUILD_IS_TOP_LEVEL)
  SET(Mummy_INSTALL_PREFIX "${CMAKE_BINARY_DIR} Install" CACHE STRING "")
  SET(CMAKE_INSTALL_PREFIX "${Mummy_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
ENDIF(Mummy_BUILD_IS_TOP_LEVEL)

# Source control system keyword substitutions (from the last
# time *this* file was committed):
#
SET(Mummy_SCS_Author "$Author: david.cole $")
SET(Mummy_SCS_Date "$Date: 2011-01-27 $")
SET(Mummy_SCS_Id "$Id: CMakeLists.txt $")
SET(Mummy_SCS_Revision "$Revision: 599 $")
SET(Mummy_SCS_URL "$URL: git://public.kitware.com/mummy.git $")

# Use these settings when building with the Msvc compiler:
#
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/MsvcMacros.cmake")
MSVC_LINK_TO_STATIC_CRT()
MSVC80_FORCE_MANIFEST_LINKER_FLAG()
MSVC_SUPPRESS_CRT_DEPRECATED_WARNINGS()

# All exes and libs should end up in the "bin" directory:
#
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/bin" CACHE INTERNAL
    "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)

IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/bin" CACHE INTERNAL
    "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)

# Name of the library that clients need to link to for building "export layer"
# code that links to the mummy runtime library. This values gets configured
# into the MummyConfig variable Mummy_RUNTIME_LINK_LIBRARIES. Clients should
# link to it with:
#
#   target_link_libraries(ClientExportLayerLib ${Mummy_RUNTIME_LINK_LIBRARIES})
#
IF(WIN32)
  SET(Mummy_RUNTIME_UNMANAGED_LINK_LIBRARY
    "Kitware.mummy.Runtime.Unmanaged.lib")
ELSE()
  SET(Mummy_RUNTIME_UNMANAGED_LINK_LIBRARY
    "libKitware.mummy.Runtime.Unmanaged.so")
ENDIF()

# Sort configuration types according to the order we'd like to find them in
# if multiple ones exist in the build tree and we're looking at mummy from
# an external project that is trying to use it.
#
IF(CMAKE_CONFIGURATION_TYPES)
  SET(
    Mummy_CMAKE_CONFIGURATION_TYPES
    "Release"
    "MinSizeRel"
    "RelWithDebInfo"
    "Debug"
    )
ELSE(CMAKE_CONFIGURATION_TYPES)
  SET(Mummy_CMAKE_CONFIGURATION_TYPES)
ENDIF(CMAKE_CONFIGURATION_TYPES)

# 32-bit build? (CableSwig, gccxml and mummy.exe only get built for 32-bit builds.
# The mummy Runtime components get built for both 32-bit and 64-bit builds.)
#
IF(NOT DEFINED Mummy_BUILD_COMPONENT_CABLESWIG)
  SET(Mummy_BUILD_COMPONENT_CABLESWIG 1)
ENDIF(NOT DEFINED Mummy_BUILD_COMPONENT_CABLESWIG)

IF(NOT DEFINED Mummy_BUILD_COMPONENT_MUMMY)
  SET(Mummy_BUILD_COMPONENT_MUMMY 1)
ENDIF(NOT DEFINED Mummy_BUILD_COMPONENT_MUMMY)

IF(NOT DEFINED Mummy_BUILD_COMPONENT_MUMMY_RUNTIME)
  SET(Mummy_BUILD_COMPONENT_MUMMY_RUNTIME 1)
ENDIF(NOT DEFINED Mummy_BUILD_COMPONENT_MUMMY_RUNTIME)

SET(Mummy_32_BIT 1)

IF("${CMAKE_GENERATOR}" MATCHES " Win64$")
  SET(Mummy_32_BIT 0)
ENDIF("${CMAKE_GENERATOR}" MATCHES " Win64$")

IF("${CMAKE_SIZEOF_VOID_P}" GREATER 4)
  SET(Mummy_32_BIT 0)
ENDIF("${CMAKE_SIZEOF_VOID_P}" GREATER 4)

IF(NOT Mummy_32_BIT)
  IF(Mummy_64_JUST_BUILD_RUNTIME)
    SET(Mummy_BUILD_COMPONENT_CABLESWIG 0)
    SET(Mummy_BUILD_COMPONENT_MUMMY 0)
  ENDIF(Mummy_64_JUST_BUILD_RUNTIME)
ENDIF(NOT Mummy_32_BIT)

# Provide mummy and C# settings at the top level so runtime, test and
# example sub-projects can use them:
#
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CvsMacros.cmake")
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/FindCsharp.cmake")
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/MummyCMakeMacros.cmake")
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/SvnMacros.cmake")

SET(mummy_EXECUTABLE "${EXECUTABLE_OUTPUT_PATH}/${CMAKE_CFG_INTDIR}/mummy${CMAKE_EXECUTABLE_SUFFIX}")

# If the parent dir is named exactly "ActiViz" then create external source
# trees as siblings of "ActiViz" - otherwise create them as siblings of
# "${CMAKE_CURRENT_SOURCE_DIR}"
#
GET_FILENAME_COMPONENT(Mummy_PARENT_DIR "${CMAKE_CURRENT_SOURCE_DIR}" PATH)
SET(Mummy_REL_EXPR "..")
IF("${Mummy_PARENT_DIR}" MATCHES "/ActiViz$")
  SET(Mummy_REL_EXPR "../..")
ENDIF("${Mummy_PARENT_DIR}" MATCHES "/ActiViz$")
GET_FILENAME_COMPONENT(Mummy_EXTERNAL_SOURCE_TREES_DIR
  "${CMAKE_CURRENT_SOURCE_DIR}/${Mummy_REL_EXPR}/mummyExternalSourceTrees" ABSOLUTE)

SET(Mummy_CableSwig_CVS_REVISION "-D;2009-06-12 20:00:00 UTC")
SET(Mummy_CableSwig_PARENT_DIR "${Mummy_EXTERNAL_SOURCE_TREES_DIR}")
SET(Mummy_CableSwig_SOURCE_DIR "${Mummy_CableSwig_PARENT_DIR}/CableSwig")
SET(Mummy_CableSwig_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/CableSwigBuild")

# Echo selected CMake/configuration settings:
#
FOREACH(v
  CMAKE_SIZEOF_VOID_P
  Mummy_32_BIT
  Mummy_BUILD_COMPONENT_CABLESWIG
  Mummy_BUILD_COMPONENT_MUMMY
  Mummy_BUILD_COMPONENT_MUMMY_RUNTIME
  Mummy_CableSwig_CVS_REVISION
  Mummy_EXTERNAL_SOURCE_TREES_DIR
  Mummy_TESTING_CONFIG_PREFIX
  )
  MESSAGE(STATUS "${v}='${${v}}'")
ENDFOREACH(v)

SET(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT 0)
IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")
  SET(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT 1)
ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")

# Retrieve current state of the source tree according to svn,
# if this source tree is an svn checkout. Otherwise, status
# is just empty...
#
SET(Mummy_SVN_STATUS "")
IF(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT)
  SVN_STATUS("${CMAKE_CURRENT_SOURCE_DIR}" Mummy_SVN_STATUS)
ENDIF(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT)

IF("${Mummy_SVN_STATUS}" STREQUAL "")
  SET(Mummy_SVN_STATUS_BRIEF "")
  SET(Mummy_SVN_STATUS_ENCODED "")
ELSE("${Mummy_SVN_STATUS}" STREQUAL "")
  SET(Mummy_SVN_STATUS_BRIEF " [warning: experimental development build!]")
  STRING(REGEX REPLACE "\\\\" "/" Mummy_SVN_STATUS_ENCODED "${Mummy_SVN_STATUS}")
  STRING(REGEX REPLACE "\n" "\\\\n" Mummy_SVN_STATUS_ENCODED "${Mummy_SVN_STATUS_ENCODED}")
  STRING(REGEX REPLACE "\"" "\\\\\"" Mummy_SVN_STATUS_ENCODED "${Mummy_SVN_STATUS_ENCODED}")
ENDIF("${Mummy_SVN_STATUS}" STREQUAL "")

# Pull in FindSubversion.cmake to get the Subversion_WC_INFO macro:
#

SET(Mummy_VERSION_SVN_REVISION "599")
  #
  # This value is an artificial number that is simply incremented manually
  # now after switching to git from svn... Whenever we do "real packaging
  # releases" this number should be incremented manually until this code
  # is updated to reflect our shiny, new git repo-ness.

IF(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT)
  SET(Subversion_SVN_EXECUTABLE "${svn_EXECUTABLE}")
  FIND_PACKAGE(Subversion)
  IF(Subversion_FOUND)
    Subversion_WC_INFO("${Mummy_SOURCE_DIR}" Mummy)
    SET(Mummy_VERSION_SVN_REVISION "${Mummy_WC_LAST_CHANGED_REV}")

    # Now the following variables are available for use:
  #  MESSAGE("Subversion_VERSION_SVN='${Subversion_VERSION_SVN}'")
  #  MESSAGE("Subversion_LAST_CHANGED_LOG='${Subversion_LAST_CHANGED_LOG}'")
  #  MESSAGE("Mummy_WC_INFO='${Mummy_WC_INFO}'")
  #  MESSAGE("Mummy_WC_URL='${Mummy_WC_URL}'")
  #  MESSAGE("Mummy_WC_REVISION='${Mummy_WC_REVISION}'")
  #  MESSAGE("Mummy_WC_LAST_CHANGED_AUTHOR='${Mummy_WC_LAST_CHANGED_AUTHOR}'")
  #  MESSAGE("Mummy_WC_LAST_CHANGED_REV='${Mummy_WC_LAST_CHANGED_REV}'")
  #  MESSAGE("Mummy_WC_LAST_CHANGED_DATE='${Mummy_WC_LAST_CHANGED_DATE}'")
  ENDIF(Subversion_FOUND)
ENDIF(Mummy_SOURCE_TREE_IS_SVN_CHECKOUT)

# After getting svn info and status we can set Mummy_FULL_VERSION_STRING:
#
SET(Mummy_FULL_VERSION_STRING "mummy version ${Mummy_VERSION_STRING} (revision ${Mummy_VERSION_SVN_REVISION})${Mummy_SVN_STATUS_BRIEF}")


# Settings required to use the Cable and gxsys libs:
#
SET(Mummy_include_dirs
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${CMAKE_CURRENT_BINARY_DIR}"
  "${Mummy_CableSwig_SOURCE_DIR}"
  "${Mummy_CableSwig_SOURCE_DIR}/Cable"
  "${Mummy_CableSwig_BINARY_DIR}/Cable"
  "${Mummy_CableSwig_SOURCE_DIR}/Cable/CxxTypes"
  "${Mummy_CableSwig_SOURCE_DIR}/Cable/Generators"
  "${Mummy_CableSwig_SOURCE_DIR}/Cable/Parsers"
  "${Mummy_CableSwig_BINARY_DIR}/GCC_XML"
  )

INCLUDE_DIRECTORIES(${Mummy_include_dirs})

# Always true - see Cable/CxxTypes/CMakeLists.txt
#
ADD_DEFINITIONS(-D_cxx_STATIC)

# Also, do not install any Cable headers with mummy installation
# (also in Cable/CxxTypes/CMakeLists.txt)
#
SET(CABLE_NO_INSTALL_FACILITIES 1)

# "Near copy" of kwsys related settings from CableSwig/GCC_XML/CMakeLists.txt:
#
SET(Mummy_save_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})
SET(BUILD_SHARED_LIBS 0)
#SET(LIBRARY_OUTPUT_PATH ${GCCXML_BINARY_DIR}/KWSys)
SET(KWSYS_NAMESPACE gxsys)
SET(KWSYS_USE_Process 1)
SET(KWSYS_USE_RegularExpression 1)
SET(KWSYS_USE_SystemTools 1)
SET(KWSYS_HEADER_ROOT "${Mummy_CableSwig_BINARY_DIR}/GCC_XML")
#IF("${CMAKE_SYSTEM}" MATCHES "AIX") # mummy does not build on AIX
#  SET(KWSYS_LFS_DISABLE 1)
#ENDIF("${CMAKE_SYSTEM}" MATCHES "AIX")
#INCLUDE_DIRECTORIES(${GCCXML_BINARY_DIR}) # done later

# Make sure gxsys gets built with CommandLineArguments support:
#
SET(KWSYS_USE_CommandLineArguments 1)

# Always enable and build Testing and Documentation if building as a top
# level project.
#
OPTION(Mummy_RUN_LONG_TESTS "Run mummy tests that take more than a few seconds to run..." ON)
IF(Mummy_BUILD_IS_TOP_LEVEL)
  SET(Mummy_BUILD_EXAMPLES 1)

  # Avoid the "Continuous, Experimental, Nightly and NightlyMemoryCheck" custom
  # targets for Visual Studio builds:
  #
  IF(CMAKE_GENERATOR MATCHES "Visual Studio")
  IF(COMMAND SET_PROPERTY)
    SET_PROPERTY(GLOBAL PROPERTY CTEST_TARGETS_ADDED 1)
  ENDIF(COMMAND SET_PROPERTY)
  ENDIF(CMAKE_GENERATOR MATCHES "Visual Studio")

  INCLUDE(CTest)

  ENABLE_TESTING()
  SET(Mummy_BUILD_TESTING 1)

  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/CTestCustom.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/CTestCustom.cmake
    @ONLY
    )
ENDIF(Mummy_BUILD_IS_TOP_LEVEL)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/MummyVersion.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/MummyVersion.h"
  @ONLY
  )

SET(MummyRC_RC_FILE_NAME "MummyExe.rc")
SET(MummyRC_FILE_DESCRIPTION "${Mummy_FULL_VERSION_STRING} - command line executable")
SET(MummyRC_ORIGINAL_FILENAME "mummy${CMAKE_EXECUTABLE_SUFFIX}")
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/MummyVersion.rc.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${MummyRC_RC_FILE_NAME}"
  @ONLY
  )

# Enable other projects to use mummy via CMake's FIND_PACKAGE(mummy)
#
CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/MummyConfig.cmake.in
  ${Mummy_BINARY_DIR}/share/mummy-${Mummy_VERSION_STRING}/MummyConfig.cmake
  @ONLY
  )

# Configure these files (in addition to having custom build/install rules for
# them later) so that doing a find_package(Mummy) down in the "Examples" will
# be able to read these files during this CMake configure...
#
foreach(f FindCsharp.cmake MummyCMakeMacros.cmake)
  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/${f}
    ${Mummy_BINARY_DIR}/share/mummy-${Mummy_VERSION_STRING}/${f}
    COPYONLY
    )
endforeach()


# Get a "known to be good" CableSwig snapshot:
#
IF(Mummy_BUILD_COMPONENT_CABLESWIG OR Mummy_BUILD_COMPONENT_MUMMY)
  SET(Mummy_UPDATE_CABLESWIG 1)

  IF(NOT Mummy_CableSwig_CVS_REVISION STREQUAL "")
    IF("${Mummy_CableSwig_PARENT_DIR}/CableSwig/CMakeFiles/cvs-up-args.txt" IS_NEWER_THAN "${CMAKE_CURRENT_BINARY_DIR}/MummyVersion.h")
      SET(Mummy_UPDATE_CABLESWIG 0)
    ENDIF("${Mummy_CableSwig_PARENT_DIR}/CableSwig/CMakeFiles/cvs-up-args.txt" IS_NEWER_THAN "${CMAKE_CURRENT_BINARY_DIR}/MummyVersion.h")

    IF(NOT EXISTS "${Mummy_CableSwig_PARENT_DIR}")
      SET(Mummy_UPDATE_CABLESWIG 1)
    ENDIF(NOT EXISTS "${Mummy_CableSwig_PARENT_DIR}")
  ENDIF(NOT Mummy_CableSwig_CVS_REVISION STREQUAL "")

=== debian/changelog ===
mummy (1.0.2-5) unstable; urgency=low

  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias, remove DMUA flag
  * Remove SONAME in C# module, breaks debian policy. Closes: #671845

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 May 2012 17:27:30 +0200

mummy (1.0.2-4) unstable; urgency=low

  [ Iain Lane ]
  * Use Debian's default compiler /usr/bin/mono-csc. Closes: #652976

  [ Mathieu Malaterre ]
  * Use dh_installdocs for docs
  * Use SVG output for graph
  * Remove *.md5 from doxygen output

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 28 Dec 2011 16:04:30 +0100

mummy (1.0.2-3) unstable; urgency=low

  * Fix failure on buildd since -indep is ran anyway

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 28 Dec 2011 11:28:11 +0100

mummy (1.0.2-2) unstable; urgency=low

  * Update mummy man page.
  * Remove quilt B-D.
  * Properly set documentation variable in d/rules.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 27 Dec 2011 17:24:27 +0100

mummy (1.0.2-1) unstable; urgency=low

  * Initial release (Closes: #611789)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 19 Oct 2011 15:38:05 +0200

=== debian/control ===
Source: mummy
Section: devel
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
 mono-devel, cli-common-dev (>= 0.5.7), libcableswig-dev, libgccxml-dev, libexpat-dev
Build-Depends-Indep: doxygen (>= 1.6.2), graphviz
Standards-Version: 3.9.3
Homepage: http://www.kitware.com/products/avdownload.php
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/mummy/trunk
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/mummy/trunk/

Package: mummy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gccxml
Description: command line executable that generates C# wrappers from gccxml output
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.

Package: libkitware-mummy-runtime1.0-cil
Architecture: any
Section: cli-mono
Depends: ${shlibs:Depends}, ${misc:Depends}, ${cli:Depends}
Suggests: gccxml
Description: Mummy CLI bindings
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.
 .
 CLI bindings to the Kitware.mummy.Runtime library.

Package: mummy-doc
Architecture: all
Depends: ${misc:Depends}, doc-base
Suggests: vtk-doc
Section: doc
Description: mummy class reference documentation
 mummy is a command line executable that generates C# wrappers from gccxml
 output. A C# class is generated to wrap the wrappable class named in the gccxml
 output. Settings to control the wrapping are given inline directly in the class
 header file or in the MummySettings.xml input file.
 .
 This package contains exhaustive HTML documentation for the all the
 documented mummy C++ classes.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS += \
	-DMummy_INSTALL_PREFIX:PATH=/usr \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DMUMMY_RUNTIME_UNMANAGED_INSTALL_LIB_DIR:STRING=lib/cli/Kitware.mummy.Runtime-1.0 \
	-DMummy_SNKEYFILE:STRING=/usr/share/cli-common/keys/mono.snk \
	-Dcsc_EXECUTABLE=/usr/bin/mono-csc

# B-D-I is still not quite right on buildd, but anyway let's be prepared:
#ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
#  CMAKE_FLAGS += -DMummy_BUILD_DOCUMENTATION:BOOL=OFF
#else
#  CMAKE_FLAGS += -DMummy_BUILD_DOCUMENTATION:BOOL=ON
#endif

%:
	dh $@ --parallel --with cli

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_installdocs:
	# doxgen create md5 file for bookkeeping do not install them:
	dh_installdocs -X.md5

override_dh_compress:
	# do not compress .map file for doxygen graph
	dh_compress -X.map

debian/mummy.1: debian/mummy.1.in
	help2man --include=debian/mummy.1.in \
		--output=debian/mummy.1 --no-info mummy

get-orig-source:
	./debian/get-orig-source.sh

## mummy 1.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 #
 SET(Mummy_VERSION_MAJOR 1)
 SET(Mummy_VERSION_MINOR 0)
-SET(Mummy_VERSION_PATCH 2)
+SET(Mummy_VERSION_PATCH 3)
 SET(Mummy_VERSION_STRING "${Mummy_VERSION_MAJOR}.${Mummy_VERSION_MINOR}.${Mummy_VERSION_PATCH}")
 IF(Mummy_BUILD_IS_TOP_LEVEL)
   SET(Mummy_INSTALL_PREFIX "${CMAKE_BINARY_DIR} Install" CACHE STRING "")

=== Examples/CMakeLists.txt ===
SET(Vehicles_BUILD_TESTING 1)
ADD_SUBDIRECTORY(Vehicles)

=== MummyTesting/CMakeLists.txt ===
IF(csc_EXECUTABLE)
  # "/?" works with csc from Microsoft and its variations (gmcs and friends)
  # from Mono
  #
  ADD_TEST(HelpSmokeTest-csc "${csc_EXECUTABLE}" "/?")
ENDIF(csc_EXECUTABLE)

IF(gccxml_EXECUTABLE)
  ADD_TEST(HelpSmokeTest-gccxml "${gccxml_EXECUTABLE}" "--help")
  ADD_TEST(VersionSmokeTest-gccxml "${gccxml_EXECUTABLE}" "--version")
ENDIF(gccxml_EXECUTABLE)

IF(mono_EXECUTABLE)
  ADD_TEST(HelpSmokeTest-mono "${mono_EXECUTABLE}" "--help")
  ADD_TEST(VersionSmokeTest-mono "${mono_EXECUTABLE}" "--version")
ENDIF(mono_EXECUTABLE)

IF(EXECUTABLE_OUTPUT_PATH)
  SET(exefile ${EXECUTABLE_OUTPUT_PATH}/mummy)
ELSE(EXECUTABLE_OUTPUT_PATH)
  SET(exefile mummy)
ENDIF(EXECUTABLE_OUTPUT_PATH)

ADD_TEST(HelpSmokeTest-mummy "${exefile}" "--help")
ADD_TEST(VersionSmokeTest-mummy "${exefile}" "--version")

ADD_SUBDIRECTORY(HandCrafted)
ADD_SUBDIRECTORY(Simple)
ADD_SUBDIRECTORY(SuppressWarnings)

=== Runtime/CMakeLists.txt ===
PROJECT(MummyRuntime)


SET(MummyRC_RC_FILE_NAME "MummyRuntime.rc")
SET(MummyRC_FILE_DESCRIPTION "${Mummy_FULL_VERSION_STRING} - mummy runtime dll")
SET(MummyRC_ORIGINAL_FILENAME "${CMAKE_SHARED_LIBRARY_PREFIX}Kitware.mummy.Runtime.Unmanaged${CMAKE_SHARED_LIBRARY_SUFFIX}")
CONFIGURE_FILE(
  "${Mummy_SOURCE_DIR}/MummyVersion.rc.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${MummyRC_RC_FILE_NAME}"
  @ONLY
  )


ADD_LIBRARY(
  Kitware.mummy.Runtime.Unmanaged SHARED
  MummyRuntime.cxx
  MummyRuntime.h
  MummyTypeEntry.cxx
  MummyTypeEntry.h
  "${CMAKE_CURRENT_BINARY_DIR}/MummyRuntime.rc"
  )

INSTALL(TARGETS
  Kitware.mummy.Runtime.Unmanaged
  DESTINATION "bin"
  )


# This string should be the same string as the C++ return value from this code:
#   MRSmokeTest *test;
#   return typeid(*test).name();
#
SET(MRSMOKETEST_CLASS_NAME_KEY "ERROR_unknown_MRSmokeTest_class_name_key")
IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(MRSMOKETEST_CLASS_NAME_KEY "11MRSmokeTest")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)
IF(MSVC)
  SET(MRSMOKETEST_CLASS_NAME_KEY "class MRSmokeTest")
ENDIF(MSVC)


CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/AssemblyInfo.cs.in"
  "${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs"
  @ONLY
  )

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/MummyRuntime.cs.in"
  "${CMAKE_CURRENT_BINARY_DIR}/MummyRuntime.cs"
  @ONLY
  )

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/MRSmokeTest.cs.in"
  "${CMAKE_CURRENT_BINARY_DIR}/MRSmokeTest.cs"
  @ONLY
  )


# If a real strong name signing keyfile has not been predefined,
# then use the public key file in the source tree to /delaysign
# .NET assemblies...
#
IF(NOT Mummy_SNKEYFILE)
  GET_FILENAME_COMPONENT(Mummy_SNKEYFILE "${CMAKE_CURRENT_SOURCE_DIR}/Kitware.mummy.Runtime.pub.snk" ABSOLUTE)
ENDIF(NOT Mummy_SNKEYFILE)
MESSAGE(STATUS "Mummy_SNKEYFILE='${Mummy_SNKEYFILE}'")


ADD_CSHARP_LIBRARY(
  "Kitware.mummy.Runtime" # name of library
  "Kitware.mummy.Runtime.Unmanaged" # list of CMake targets that need to build first
  "" # list of csc "/reference:" args
  "${CMAKE_SHARED_LIBRARY_PREFIX}Kitware.mummy.Runtime.Unmanaged${CMAKE_SHARED_LIBRARY_SUFFIX}" # list of csc "/linkresource:" args
  "${Mummy_SNKEYFILE}" # strong name signing keyfile
  # Source files:
  "${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs"
  "${CMAKE_CURRENT_BINARY_DIR}/MummyRuntime.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/WrappedException.cs"
  "${CMAKE_CURRENT_SOURCE_DIR}/WrappedObject.cs"
  )


ADD_LIBRARY(MRSmokeTest SHARED MRSmokeTest.cxx)
TARGET_LINK_LIBRARIES(MRSmokeTest Kitware.mummy.Runtime.Unmanaged)


ADD_EXECUTABLE(MRSmokeTestMain MRSmokeTestMain.cxx)
TARGET_LINK_LIBRARIES(MRSmokeTestMain MRSmokeTest)


ADD_CSHARP_LIBRARY(
  "Kitware.mummy.Runtime.SmokeTest"
  "Kitware.mummy.Runtime;MRSmokeTest"
  "Kitware.mummy.Runtime"
  ""
  ""
  "${CMAKE_CURRENT_BINARY_DIR}/MRSmokeTest.cs"
  )


ADD_CSHARP_EXECUTABLE(
  "Kitware.mummy.Runtime.SmokeTestMain"
  "Kitware.mummy.Runtime.SmokeTest"
  "Kitware.mummy.Runtime.SmokeTest;Kitware.mummy.Runtime"
  ""
  ""
  "${CMAKE_CURRENT_SOURCE_DIR}/MRSmokeTestMain.cs"
  )


ADD_CSHARP_EXECUTABLE(
  "Kitware.mummy.Runtime.CreateTestMain"
  "Kitware.mummy.Runtime.SmokeTest"
  "Kitware.mummy.Runtime.SmokeTest;Kitware.mummy.Runtime"
  ""
  ""
  "${CMAKE_CURRENT_SOURCE_DIR}/CreateTestMain.cs"
  )


#MESSAGE(STATUS "Mummy_BUILD_TESTING='${Mummy_BUILD_TESTING}'")
IF(Mummy_BUILD_TESTING)
  SET(testexe MRSmokeTestMain)
  IF(EXECUTABLE_OUTPUT_PATH)
    SET(exefile ${EXECUTABLE_OUTPUT_PATH}/${Mummy_TESTING_CONFIG_PREFIX}${testexe})
  ELSE(EXECUTABLE_OUTPUT_PATH)
    SET(exefile ${testexe})
  ENDIF(EXECUTABLE_OUTPUT_PATH)
  ADD_TEST(mummyRuntimeTest-${testexe}-NoArgs "${exefile}")
  ADD_TEST(mummyRuntimeTest-${testexe} "${exefile}" "20000")
  IF(Mummy_RUN_LONG_TESTS)
    ADD_TEST(mummyRuntimeTest-${testexe}-mega "${exefile}" "1000000")
  ENDIF(Mummy_RUN_LONG_TESTS)

  IF(csc_EXECUTABLE)
    #
    # C# executables are named with ".exe" even on Mono (Linux / Mac)...
    #
    SET(testexe Kitware.mummy.Runtime.SmokeTestMain.exe)
    IF(EXECUTABLE_OUTPUT_PATH)
      SET(exefile ${EXECUTABLE_OUTPUT_PATH}/${Mummy_TESTING_CONFIG_PREFIX}${testexe})
    ELSE(EXECUTABLE_OUTPUT_PATH)
      SET(exefile ${testexe})
    ENDIF(EXECUTABLE_OUTPUT_PATH)
    ADD_CSHARP_TEST(mummyRuntimeTest-${testexe}-NoArgs "${exefile}")
    FOREACH(flag strong weak evensplit pseudorandom)
      ADD_CSHARP_TEST(mummyRuntimeTest-${testexe}-${flag} "${exefile}" "20000" "--${flag}")
      IF(Mummy_RUN_LONG_TESTS)
        ADD_CSHARP_TEST(mummyRuntimeTest-${testexe}-${flag}-mega "${exefile}" "1000000" "--${flag}")
      ENDIF(Mummy_RUN_LONG_TESTS)
    ENDFOREACH(flag)

    SET(testexe Kitware.mummy.Runtime.CreateTestMain.exe)
    IF(EXECUTABLE_OUTPUT_PATH)
      SET(exefile ${EXECUTABLE_OUTPUT_PATH}/${Mummy_TESTING_CONFIG_PREFIX}${testexe})
    ELSE(EXECUTABLE_OUTPUT_PATH)
      SET(exefile ${testexe})
    ENDIF(EXECUTABLE_OUTPUT_PATH)
    ADD_CSHARP_TEST(mummyRuntimeTest-${testexe}-NoArgs "${exefile}")
    ADD_CSHARP_TEST(mummyRuntimeTest-${testexe} "${exefile}" "20000")
    IF(Mummy_RUN_LONG_TESTS)
      ADD_CSHARP_TEST(mummyRuntimeTest-${testexe}-mega "${exefile}" "1000000")
    ENDIF(Mummy_RUN_LONG_TESTS)
  ENDIF(csc_EXECUTABLE)
ENDIF(Mummy_BUILD_TESTING)

=== Examples/Vehicles/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4 FATAL_ERROR)
PROJECT(Vehicles)


# Determine if we're building Vehicles as a "top level" project.
#
SET(Vehicles_BUILD_IS_TOP_LEVEL 0)
IF("${Vehicles_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  SET(Vehicles_BUILD_IS_TOP_LEVEL 1)
ENDIF("${Vehicles_BINARY_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")


INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/MsvcMacros.cmake")
MSVC_FORCE_WARNING_LEVEL("4")
#MSVC_TREAT_WARNINGS_AS_ERRORS()
MSVC_LINK_TO_STATIC_CRT()
MSVC80_FORCE_MANIFEST_LINKER_FLAG()


# 32 or 64 bit build?
#
SET(Vehicles_TARGET_CPU_SIZE "32")
IF(CMAKE_CL_64)
  SET(Vehicles_TARGET_CPU_SIZE "64")
ENDIF(CMAKE_CL_64)


# Debug or not for the C# layers?
#
SET(Vehicles_BUILD_CSHARP_DEBUG_DEFAULT OFF)
IF("${BUILDNAME}" MATCHES "Debug")
  SET(Vehicles_BUILD_CSHARP_DEBUG_DEFAULT ON)
ENDIF("${BUILDNAME}" MATCHES "Debug")
IF("${BUILDNAME}" MATCHES "RelWithDebInfo")
  SET(Vehicles_BUILD_CSHARP_DEBUG_DEFAULT ON)
ENDIF("${BUILDNAME}" MATCHES "RelWithDebInfo")


OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON)
OPTION(BUILD_TESTING "Build/add tests" ON)
SET(Vehicles_INSTALL_TARGETS 0)
IF(Vehicles_BUILD_IS_TOP_LEVEL)
  SET(VEHICLES_INSTALL_PREFIX "${CMAKE_BINARY_DIR} VIP Install" CACHE STRING "")
  SET(CMAKE_INSTALL_PREFIX "${VEHICLES_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
  SET(Vehicles_INSTALL_TARGETS 1)
ENDIF(Vehicles_BUILD_IS_TOP_LEVEL)
OPTION(Vehicles_BUILD_CSHARP_DEBUG "Build C# components with '/debug' command line flag" ${Vehicles_BUILD_CSHARP_DEBUG_DEFAULT})


IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET(EXECUTABLE_OUTPUT_PATH "${CMAKE_BINARY_DIR}/bin" CACHE STRING "")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
IF(NOT LIBRARY_OUTPUT_PATH)
  SET(LIBRARY_OUTPUT_PATH "${EXECUTABLE_OUTPUT_PATH}" CACHE STRING "")
ENDIF(NOT LIBRARY_OUTPUT_PATH)


MACRO(DEFINE_KIT kit kit_deps_var)
  SET(${kit}_classes ${ARGN} CACHE STRING "")

  SET(${kit}_deps ${${kit_deps_var}} CACHE STRING "")

  SET(${kit}_source_files "")
  FOREACH(class ${${kit}_classes})
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${class}.cxx")
      SET(${kit}_source_files ${${kit}_source_files}
        "${CMAKE_CURRENT_SOURCE_DIR}/${class}.cxx"
      )
    ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${class}.cxx")
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${class}.h")
      SET(${kit}_source_files ${${kit}_source_files}
        "${CMAKE_CURRENT_SOURCE_DIR}/${class}.h"
      )
    ENDIF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${class}.h")
  ENDFOREACH(class)
  SET(deffile "${CMAKE_CURRENT_SOURCE_DIR}/${kit}${Vehicles_TARGET_CPU_SIZE}.def")
  IF(EXISTS "${deffile}")
    SET(${kit}_source_files ${${kit}_source_files} "${deffile}")
  ENDIF(EXISTS "${deffile}")
  SET(${kit}_source_files ${${kit}_source_files} CACHE STRING "")

  SET(${kit}_include_dirs "${Vehicles_SOURCE_DIR}/${kit}" CACHE STRING "")

  SET(${kit}_libs "${kit}" CACHE STRING "")

  MARK_AS_ADVANCED(${kit}_classes)
  MARK_AS_ADVANCED(${kit}_deps)
  MARK_AS_ADVANCED(${kit}_source_files)
  MARK_AS_ADVANCED(${kit}_include_dirs)
  MARK_AS_ADVANCED(${kit}_libs)
ENDMACRO(DEFINE_KIT)


MACRO(ECHO_KIT kit)
  MESSAGE(STATUS "${kit}_classes='${${kit}_classes}'")
  MESSAGE(STATUS "${kit}_deps='${${kit}_deps}'")
  MESSAGE(STATUS "${kit}_include_dirs='${${kit}_include_dirs}'")
  MESSAGE(STATUS "${kit}_libs='${${kit}_libs}'")
  MESSAGE(STATUS "${kit}_source_files='${${kit}_source_files}'")
ENDMACRO(ECHO_KIT)


CONFIGURE_FILE(
  "${Vehicles_SOURCE_DIR}/VehiclesConfig.h.in"
  "${Vehicles_BINARY_DIR}/VehiclesConfig.h"
)


INCLUDE_DIRECTORIES(${Vehicles_SOURCE_DIR})
INCLUDE_DIRECTORIES(${Vehicles_BINARY_DIR})
LINK_DIRECTORIES(${EXECUTABLE_OUTPUT_PATH})
LINK_DIRECTORIES(${LIBRARY_OUTPUT_PATH})


MACRO(ADD_KIT kit)
  INCLUDE_DIRECTORIES("${Vehicles_SOURCE_DIR}/${kit}")
  SET(Vehicles_kits ${Vehicles_kits} "${kit}")
  ADD_SUBDIRECTORY("${kit}")
  #ECHO_KIT("${kit}")
ENDMACRO(ADD_KIT)


SET(Vehicles_kits "")

ADD_KIT(base)
ADD_KIT(cars)
ADD_KIT(motorcycles)
ADD_KIT(suvs)

# Always enable and build Testing if building as a top level project.
#
IF(Vehicles_BUILD_IS_TOP_LEVEL)
  INCLUDE(CTest)
  ENABLE_TESTING()
  SET(Vehicles_BUILD_TESTING 1)
ENDIF(Vehicles_BUILD_IS_TOP_LEVEL)

IF(Vehicles_BUILD_TESTING)
  ADD_KIT(tests)
ENDIF(Vehicles_BUILD_TESTING)

SET(Vehicles_kits ${Vehicles_kits} CACHE STRING "")
MARK_AS_ADVANCED(Vehicles_kits)


ADD_SUBDIRECTORY(wrappers)

=== MummyTesting/HandCrafted/CMakeLists.txt ===
# Build as is, force static lib:
#
ADD_LIBRARY(handCraftedLib STATIC simple.cxx)

# Forcing static lib on Linux means we have to use the -fPIC flag for compiling
# sources in the target:
#
IF(NOT WIN32 AND NOT APPLE)
  SET_TARGET_PROPERTIES(handCraftedLib PROPERTIES COMPILE_FLAGS "-fPIC")
ENDIF(NOT WIN32 AND NOT APPLE)

# Build wrapper layers:
#
# Both gccxml_EXECUTABLE and mummy_EXECUTABLE should have been found by parent
# project... verify:
#
IF(NOT gccxml_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no gccxml_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT gccxml_EXECUTABLE)
IF(NOT mummy_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no mummy_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT mummy_EXECUTABLE)

SET(gccxml_output "${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.xml")
SET(mummy_exportlayer_output "${CMAKE_CURRENT_BINARY_DIR}/simple_exportlayer.cxx")
SET(mummy_csharp_output "${CMAKE_CURRENT_BINARY_DIR}/handCraftedSimple.cs")
SET(mummy_settings "${CMAKE_CURRENT_SOURCE_DIR}/handCraftedMummySettings.xml")

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/handCraftedSimple.cs"
  "${CMAKE_CURRENT_BINARY_DIR}/handCraftedSimpleExtra.cs"
  @ONLY
  )

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/simple_gccxml.cxx.in"
  "${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx"
  @ONLY
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${gccxml_output}
  COMMAND ${gccxml_EXECUTABLE}
  ARGS
    -fxml=${gccxml_output}
    -fxml-start=_cable_
    -I${CMAKE_CURRENT_SOURCE_DIR}
    -DCABLE_CONFIGURATION
    --gccxml-compiler ${CMAKE_CXX_COMPILER}
    ${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/simple.h
    ${gccxml_EXECUTABLE}
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${mummy_csharp_output} ${mummy_exportlayer_output}
  COMMAND ${mummy_EXECUTABLE}
  ARGS
    --settings-file ${mummy_settings}
    --gccxml-file ${gccxml_output}
    --csharp-file ${mummy_csharp_output}
    --export-layer-file ${mummy_exportlayer_output}
  DEPENDS
    ${mummy_settings}
    ${gccxml_output}
    ${mummy_EXECUTABLE}
  )

# Build the "export-layer" library:
#
ADD_LIBRARY(handCraftedExportLayer SHARED ${mummy_exportlayer_output})
TARGET_LINK_LIBRARIES(handCraftedExportLayer
  handCraftedLib
  Kitware.mummy.Runtime.Unmanaged
  )

=== MummyTesting/Simple/CMakeLists.txt ===
# Build as is, force static lib:
#
ADD_LIBRARY(simpleLib STATIC simple.cxx)

# Forcing static lib on Linux means we have to use the -fPIC flag for compiling
# sources in the target:
#
IF(NOT WIN32 AND NOT APPLE)
  SET_TARGET_PROPERTIES(simpleLib PROPERTIES COMPILE_FLAGS "-fPIC")
ENDIF(NOT WIN32 AND NOT APPLE)

ADD_EXECUTABLE(simpleLibTest main.cxx)
TARGET_LINK_LIBRARIES(simpleLibTest simpleLib)

# Test it:
#
IF(EXECUTABLE_OUTPUT_PATH)
  SET(exefile ${EXECUTABLE_OUTPUT_PATH}/simpleLibTest)
ELSE(EXECUTABLE_OUTPUT_PATH)
  SET(exefile simpleLibTest)
ENDIF(EXECUTABLE_OUTPUT_PATH)

ADD_TEST(MT-simpleLibTest "${exefile}")

# Build wrapper layers:
#
# Both gccxml_EXECUTABLE and mummy_EXECUTABLE should have been found by parent
# project... verify:
#
IF(NOT gccxml_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no gccxml_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT gccxml_EXECUTABLE)
IF(NOT mummy_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no mummy_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT mummy_EXECUTABLE)

SET(gccxml_output "${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.xml")
SET(mummy_exportlayer_output "${CMAKE_CURRENT_BINARY_DIR}/simple_exportlayer.cxx")
SET(mummy_csharp_output "${CMAKE_CURRENT_BINARY_DIR}/simple.cs")

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/simple_gccxml.cxx.in"
  "${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx"
  @ONLY
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${gccxml_output}
  COMMAND ${gccxml_EXECUTABLE}
  ARGS
    -fxml=${gccxml_output}
    -fxml-start=_cable_
    -I${CMAKE_CURRENT_SOURCE_DIR}
    -DCABLE_CONFIGURATION
    --gccxml-compiler ${CMAKE_CXX_COMPILER}
    ${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/simple_gccxml.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/simple.h
    ${gccxml_EXECUTABLE}
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${mummy_csharp_output} ${mummy_exportlayer_output}
  COMMAND ${mummy_EXECUTABLE}
  ARGS
    --settings-file ${CMAKE_CURRENT_SOURCE_DIR}/simpleMummySettings.xml
    --gccxml-file ${gccxml_output}
    --csharp-file ${mummy_csharp_output}
    --export-layer-file ${mummy_exportlayer_output}
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/simpleMummySettings.xml
    ${gccxml_output}
    ${mummy_EXECUTABLE}
  )

# Build the "export-layer" library:
#
ADD_LIBRARY(simpleExportLayer SHARED ${mummy_exportlayer_output})
TARGET_LINK_LIBRARIES(simpleExportLayer
  Kitware.mummy.Runtime.Unmanaged
  simpleLib
  )

ADD_EXECUTABLE(simpleExportLayerTest simpleExportLayerTest.cxx)
TARGET_LINK_LIBRARIES(simpleExportLayerTest
  simpleExportLayer
  )

# Test it:
#
IF(EXECUTABLE_OUTPUT_PATH)
  SET(exefile ${EXECUTABLE_OUTPUT_PATH}/simpleExportLayerTest)
ELSE(EXECUTABLE_OUTPUT_PATH)
  SET(exefile simpleExportLayerTest)
ENDIF(EXECUTABLE_OUTPUT_PATH)

ADD_TEST(MT-simpleExportLayerTest "${exefile}")

=== MummyTesting/SuppressWarnings/CMakeLists.txt ===
SET(MTprefix "MTSuppressWarnings")

# Build as is, force static lib:
#
ADD_LIBRARY(${MTprefix}Lib STATIC simple.cxx)

# Forcing static lib on Linux means we have to use the -fPIC flag for compiling
# sources in the target:
#
IF(NOT WIN32 AND NOT APPLE)
  SET_TARGET_PROPERTIES(${MTprefix}Lib PROPERTIES COMPILE_FLAGS "-fPIC")
ENDIF(NOT WIN32 AND NOT APPLE)

# Build wrapper layers:
#
# Both gccxml_EXECUTABLE and mummy_EXECUTABLE should have been found by parent
# project... verify:
#
IF(NOT gccxml_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no gccxml_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT gccxml_EXECUTABLE)
IF(NOT mummy_EXECUTABLE)
  MESSAGE(FATAL_ERROR "error: no mummy_EXECUTABLE - cannot build wrapper layers")
ENDIF(NOT mummy_EXECUTABLE)

SET(gccxml_output "${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}_gccxml.xml")
SET(mummy_exportlayer_output "${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}_exportlayer.cxx")
SET(mummy_csharp_output "${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}.cs")
SET(mummy_settings "${CMAKE_CURRENT_SOURCE_DIR}/MummySettings.xml")

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/gccxml.cxx.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}_gccxml.cxx"
  @ONLY
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${gccxml_output}
  COMMAND ${gccxml_EXECUTABLE}
  ARGS
    -fxml=${gccxml_output}
    -fxml-start=_cable_
    -I${CMAKE_CURRENT_SOURCE_DIR}
    -DCABLE_CONFIGURATION
    --gccxml-compiler ${CMAKE_CXX_COMPILER}
    ${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}_gccxml.cxx
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/${MTprefix}_gccxml.cxx
    ${CMAKE_CURRENT_SOURCE_DIR}/simple.h
    ${gccxml_EXECUTABLE}
  )

# --verbose and --suppress-warnings flags intentionally added to this
# test to increase mummy coverage...
#
ADD_CUSTOM_COMMAND(
  OUTPUT ${mummy_csharp_output} ${mummy_exportlayer_output}
  COMMAND ${mummy_EXECUTABLE}
  ARGS
    --verbose
    --suppress-warnings 6008
    --settings-file ${mummy_settings}
    --gccxml-file ${gccxml_output}
    --csharp-file ${mummy_csharp_output}
    --export-layer-file ${mummy_exportlayer_output}
  DEPENDS
    ${mummy_settings}
    ${gccxml_output}
    ${mummy_EXECUTABLE}
  )

# Build the "export-layer" library:
#
ADD_LIBRARY(${MTprefix}ExportLayer SHARED ${mummy_exportlayer_output})
TARGET_LINK_LIBRARIES(${MTprefix}ExportLayer
  ${MTprefix}Lib
  Kitware.mummy.Runtime.Unmanaged
  )

=== Examples/Vehicles/base/CMakeLists.txt ===
SET(deps "")

DEFINE_KIT(
  "base" deps
  "AbstractVehicle"
  "BlatMobile"
  "FuelLevelChanged"
  "FuelLevelChangedEventArgs"
  "Oops"
  "RefCountedVehicle"
  "SignatureSeries"
  "SimpleVehicle"
  "Vehicle"
  "VehicleDescriptor"
)

# Extra files (not wrapped, or force to show up in VS project UI, for example):
SET(base_source_files ${base_source_files}
  "AbstractVehicleEvent.h"
  "InlineWrapperHints.h"
  "SenderDataEvent.h"
  "SillyString.cxx"
  "SillyString.h"
  "UnwrappedClass.cxx"
  "UnwrappedClass.h"
)

ADD_LIBRARY(base ${base_source_files})

IF(Vehicles_INSTALL_TARGETS)
  INSTALL(TARGETS base RUNTIME DESTINATION "." LIBRARY DESTINATION ".")
ENDIF(Vehicles_INSTALL_TARGETS)

=== Examples/Vehicles/cars/CMakeLists.txt ===
SET(deps "base")

DEFINE_KIT(
  "cars" deps
  "AbstractCar"
  "Mustang"
)

ADD_LIBRARY(cars ${cars_source_files})

IF(Vehicles_INSTALL_TARGETS)
  INSTALL(TARGETS cars RUNTIME DESTINATION "." LIBRARY DESTINATION ".")
ENDIF(Vehicles_INSTALL_TARGETS)

FOREACH(d ${deps})
  TARGET_LINK_LIBRARIES(cars "${${d}_libs}")
ENDFOREACH(d)

=== Examples/Vehicles/motorcycles/CMakeLists.txt ===
SET(deps "base")

DEFINE_KIT(
  "motorcycles" deps
  "GenericMotorCycle"
)

ADD_LIBRARY(motorcycles ${motorcycles_source_files})

IF(Vehicles_INSTALL_TARGETS)
  INSTALL(TARGETS motorcycles RUNTIME DESTINATION "." LIBRARY DESTINATION ".")
ENDIF(Vehicles_INSTALL_TARGETS)

FOREACH(d ${deps})
  TARGET_LINK_LIBRARIES(motorcycles "${${d}_libs}")
ENDFOREACH(d)

=== Examples/Vehicles/suvs/CMakeLists.txt ===
SET(deps "base")

DEFINE_KIT(
  "suvs" deps
  "GenericSUV"
)

ADD_LIBRARY(suvs ${suvs_source_files})

IF(Vehicles_INSTALL_TARGETS)
  INSTALL(TARGETS suvs RUNTIME DESTINATION "." LIBRARY DESTINATION ".")
ENDIF(Vehicles_INSTALL_TARGETS)

FOREACH(d ${deps})
  TARGET_LINK_LIBRARIES(suvs "${${d}_libs}")
ENDFOREACH(d)

=== debian/changelog ===
mummy (1.0.3-2) unstable; urgency=low

  * Fix ABI version. Closes: #703332
    + debian/libkitware-mummy-runtime1.0-cil.cligacpolicy

 -- Mathieu Malaterre <malat@debian.org>  Mon, 01 Apr 2013 09:33:20 +0200

mummy (1.0.3-1) unstable; urgency=low

  * New upstream
  * Bump Std-Vers to 3.9.4, no changes needed
  * Use dh(9) get hardening for free
  * Refresh patches (use DEP3 when missing)

 -- Mathieu Malaterre <malat@debian.org>  Fri, 15 Mar 2013 14:31:05 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Mathieu Malaterre <malat@debian.org>
-Build-Depends: debhelper (>= 8), cmake (>= 2.8.2),
+Build-Depends: debhelper (>= 9), cmake (>= 2.8.2),
  mono-devel, cli-common-dev (>= 0.5.7), libcableswig-dev, libgccxml-dev, libexpat-dev
 Build-Depends-Indep: doxygen (>= 1.6.2), graphviz
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.kitware.com/products/avdownload.php
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/mummy/trunk
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/mummy/trunk/

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,5 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
-
-DPKG_EXPORT_BUILDFLAGS = 1
--include /usr/share/dpkg/buildflags.mk
 
 CMAKE_FLAGS += \
 	-DMummy_INSTALL_PREFIX:PATH=/usr \
@@ -32,6 +29,10 @@
 	# do not compress .map file for doxygen graph
 	dh_compress -X.map
 
+override_dh_cligacpolicy:
+	cp /usr/share/cli-common/keys/mono.snk debian
+	dh_cligacpolicy
+
 debian/mummy.1: debian/mummy.1.in
 	help2man --include=debian/mummy.1.in \
 		--output=debian/mummy.1 --no-info mummy
